#/function terra_chapter2:encounters/wither_skeleton_twins/end
#Created by Mithey

#Kill entities
execute as @e[tag=EntityNatural] at @s run tp @s ~ ~-500 ~
kill @e[tag=EntityNatural]
execute as @e[tag=EntityBoss] at @s run tp @s ~ ~-500 ~
kill @e[tag=EntityBoss]

#Hide boss bars
bossbar set minecraft:200 visible false
bossbar set minecraft:201 visible false
bossbar set minecraft:202 visible false

#Enable natural mob spawning
function terra_system:entities/natural_mob_spawning_enable

#Ensure death is processed
execute as @a[scores={Death=1..}] at @s run function terra_chapter2:on_death

#Open gates
fill 3060 61 3075 3062 59 3075 minecraft:air

#Turn off clock
setblock ~-1 ~ ~ minecraft:lapis_block
data merge block ~ ~ ~ {Command:"function terra_chapter2:encounters/wither_skeleton_twins/attempt_start"}

#Heal player
execute as @a at @s run function terra_system:health/reset_health
execute as @a at @s run function terra_system:potions/refill_potion

#Run won/lost stuff
execute if score WonEncounter Temp matches 0 run function terra_chapter2:encounters/wither_skeleton_twins/end_lost
execute if score WonEncounter Temp matches 1 run function terra_chapter2:encounters/wither_skeleton_twins/end_won

#Remove objectives
scoreboard objectives remove EncounterTime
scoreboard objectives remove EncounterDeath
scoreboard players set TerraRestore InEncounter 0
scoreboard players reset WonEncounter Temp
scoreboard players reset Encounter Clock
scoreboard objectives remove SkeletonSpawn

#Unload chunks
execute positioned 3061 59 3077 run forceload remove ~-80 ~-80 ~80 ~80








