#/function terra_chapter2:encounters/wither_skeleton_twins/events
#Created by Mithey

scoreboard players add Encounter Clock 1

#Give players resistance effect
effect give @a minecraft:resistance 5 1 true

#Remove wither effect
effect clear @a minecraft:wither

#Spawn skeletons if on multiplayer
scoreboard players add TerraRestore SkeletonSpawn 1
execute if score TerraRestore SkeletonSpawn matches 400 run function terra_chapter2:encounters/wither_skeleton_twins/events/spawn_skeletons_attempt
execute if score TerraRestore SkeletonSpawn matches 500.. run scoreboard players set TerraRestore SkeletonSpawn 0

#Get health % for wither skeletons
scoreboard players operation HealthPercent1 Temp = @e[tag=chapter2_BossWitherSkeleton1,limit=1] EntityHpCurr
scoreboard players operation HealthPercent2 Temp = @e[tag=chapter2_BossWitherSkeleton2,limit=1] EntityHpCurr
scoreboard players operation HealthPercent1 Temp *= 100 Number
scoreboard players operation HealthPercent2 Temp *= 100 Number
scoreboard players operation HealthPercent1 Temp /= @e[tag=chapter2_BossWitherSkeleton1,limit=1] EntityHpMax
scoreboard players operation HealthPercent2 Temp /= @e[tag=chapter2_BossWitherSkeleton2,limit=1] EntityHpMax

#Manage phases
execute if score TerraRestore BossPhase matches 1 run execute if score TerraRestore Difficulty matches 1 run execute if score HealthPercent1 Temp matches ..25 run function terra_chapter2:encounters/wither_skeleton_twins/events/activate_phase2
execute if score TerraRestore BossPhase matches 1 run execute if score TerraRestore Difficulty matches 2 run execute if score HealthPercent1 Temp matches ..35 run function terra_chapter2:encounters/wither_skeleton_twins/events/activate_phase2
execute if score TerraRestore BossPhase matches 1 run execute if score TerraRestore Difficulty matches 3 run execute if score HealthPercent1 Temp matches ..45 run function terra_chapter2:encounters/wither_skeleton_twins/events/activate_phase2
execute if score TerraRestore BossPhase matches 2 run execute if score TerraRestore Difficulty matches 1 run execute if score HealthPercent2 Temp matches ..25 run function terra_chapter2:encounters/wither_skeleton_twins/events/activate_phase3
execute if score TerraRestore BossPhase matches 2 run execute if score TerraRestore Difficulty matches 2 run execute if score HealthPercent2 Temp matches ..35 run function terra_chapter2:encounters/wither_skeleton_twins/events/activate_phase3
execute if score TerraRestore BossPhase matches 2 run execute if score TerraRestore Difficulty matches 3 run execute if score HealthPercent2 Temp matches ..45 run function terra_chapter2:encounters/wither_skeleton_twins/events/activate_phase3

#Wither skeleton clocks
execute as @e[tag=chapter2_BossWitherSkeleton1] at @s run function terra_chapter2:encounters/wither_skeleton_twins/events/skeleton1_clock
execute as @e[tag=chapter2_BossWitherSkeleton2] at @s run function terra_chapter2:encounters/wither_skeleton_twins/events/skeleton2_clock

#Ability TNT clock
execute as @e[tag=chapter2_BossWitherSkeleton1,tag=AbilityTNT] at @s run function terra_chapter2:encounters/wither_skeleton_twins/tnt_ability/clock

#Wither skeleton skull object clock
execute as @e[tag=BossWitherSkeletonSkull] at @s run function terra_chapter2:encounters/wither_skeleton_twins/wither_skull/clock

#TNT object clock
execute as @e[tag=BossTNT] at @s run function terra_chapter2:encounters/wither_skeleton_twins/tnt/clock

#Clean up
scoreboard players reset HealthPercent1 Temp
scoreboard players reset HealthPercent2 Temp