#/function terra_system:abilities/striding/clock
#Created by Mithey

#Add temp tag to player's striding cat
execute if score @s PlayerID matches 1 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 1 run tag @s add TempStridingCat
execute if score @s PlayerID matches 2 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 2 run tag @s add TempStridingCat
execute if score @s PlayerID matches 3 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 3 run tag @s add TempStridingCat
execute if score @s PlayerID matches 4 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 4 run tag @s add TempStridingCat
execute if score @s PlayerID matches 5 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 5 run tag @s add TempStridingCat
execute if score @s PlayerID matches 6 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 6 run tag @s add TempStridingCat
execute if score @s PlayerID matches 7 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 7 run tag @s add TempStridingCat
execute if score @s PlayerID matches 8 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 8 run tag @s add TempStridingCat
execute if score @s PlayerID matches 9 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 9 run tag @s add TempStridingCat
execute if score @s PlayerID matches 10 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 10 run tag @s add TempStridingCat
execute if score @s PlayerID matches 11 run execute as @e[tag=Ability_StridingCat] at @s run execute if score @s CatID matches 11 run tag @s add TempStridingCat

#Temp give levitation to avoid fall damage
effect give @s minecraft:levitation 1 0 true

#Temp add stopped tag if currently stopped
execute if entity @e[tag=TempStridingCat,limit=1,sort=nearest,tag=Stopped] run scoreboard players set Stopped Temp 1

#If turn left/right active
execute as @e[tag=TempStridingCat,tag=TurnLeft] at @s run function terra_system:strider/turn_strider_left_clock
execute as @e[tag=TempStridingCat,tag=TurnRight] at @s run function terra_system:strider/turn_strider_right_clock

#If beside honey block
execute if block 111 4 -24 minecraft:green_wool run execute if block ~1 ~ ~ minecraft:honey_block run tag @e[tag=TempStridingCat,limit=1,sort=nearest] add NearHoney
execute if block 111 4 -24 minecraft:green_wool run execute if block ~-1 ~ ~ minecraft:honey_block run tag @e[tag=TempStridingCat,limit=1,sort=nearest] add NearHoney
execute if block 111 4 -24 minecraft:green_wool run execute if block ~ ~ ~1 minecraft:honey_block run tag @e[tag=TempStridingCat,limit=1,sort=nearest] add NearHoney
execute if block 111 4 -24 minecraft:green_wool run execute if block ~ ~ ~-1 minecraft:honey_block run tag @e[tag=TempStridingCat,limit=1,sort=nearest] add NearHoney

#Set cat it's proper RY/RX again
execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[0] float 0.01 run scoreboard players get @e[tag=TempStridingCat,limit=1,sort=nearest] RotationY
execute as @e[tag=TempStridingCat,limit=1,sort=nearest] at @s run tp @s ~ ~ ~ ~ 0

#Move upwards slightly if still in liquid
execute as @e[tag=TempStridingCat,limit=1,sort=nearest] at @s run execute if block ~ ~ ~ #minecraft:liquids run tp @s ~ ~0.1 ~

#Set strider's motion in a forwards direction
summon minecraft:area_effect_cloud 0.0 0.0 0.0 {Tags:["TempMotion"]}
execute as @e[tag=TempMotion] at @s run execute rotated as @e[tag=TempStridingCat] run tp @s ^ ^ ^1
execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Motion[0] double 0.0015 run data get entity @e[tag=TempMotion,limit=1,sort=nearest] Pos[0] 100
execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Motion[1] double 0.0015 run data get entity @e[tag=TempMotion,limit=1,sort=nearest] Pos[1] 100
execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Motion[2] double 0.0015 run data get entity @e[tag=TempMotion,limit=1,sort=nearest] Pos[2] 100
data merge entity @e[tag=TempStridingCat,limit=1,sort=nearest,tag=Stopped] {Motion:[0d,0d,0d]}
execute store result entity @e[tag=TempStridingCat,tag=NearHoney,limit=1,sort=nearest] Motion[1] double 0.1 run scoreboard players get 2 Number

#Temporarily set cat's RX to player's RX
execute if score @s PlayerID matches 1 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=1}] Rotation[1]
execute if score @s PlayerID matches 2 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=2}] Rotation[1]
execute if score @s PlayerID matches 3 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=3}] Rotation[1]
execute if score @s PlayerID matches 4 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=4}] Rotation[1]
execute if score @s PlayerID matches 5 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=5}] Rotation[1]
execute if score @s PlayerID matches 6 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=6}] Rotation[1]
execute if score @s PlayerID matches 7 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=7}] Rotation[1]
execute if score @s PlayerID matches 8 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=8}] Rotation[1]
execute if score @s PlayerID matches 9 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=9}] Rotation[1]
execute if score @s PlayerID matches 10 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=10}] Rotation[1]
execute if score @s PlayerID matches 11 run execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run data get entity @p[scores={PlayerID=11}] Rotation[1]

#Move player to cat
tp @s @e[tag=TempStridingCat,limit=1,sort=nearest]

#Set cat's RX back to 0
execute store result entity @e[tag=TempStridingCat,limit=1,sort=nearest] Rotation[1] float 1 run scoreboard players get 0 Number

#Remove stamina
execute unless score Stopped Temp matches 1 run scoreboard players set Amount Temp 100
execute unless score Stopped Temp matches 1 run execute if score TerraRestore StaminaUpgrade matches 1 run scoreboard players set Amount Temp 75
execute unless score Stopped Temp matches 1 run function terra_system:stamina/remove_stamina
execute if score Stopped Temp matches 1 run execute if score TerraRestore StaminaUpgrade matches 1 run scoreboard players set Amount Temp 7
execute if score Stopped Temp matches 1 run function terra_system:stamina/remove_stamina

#Sound
execute unless score Stopped Temp matches 1 run scoreboard players add @s StridingSound 1
execute unless score Stopped Temp matches 1 run execute if score @s StridingSound matches 7.. run playsound minecraft:entity.strider.step player @a
execute unless score Stopped Temp matches 1 run execute if score @s StridingSound matches 7.. run scoreboard players set @s StridingSound 0

#Particle
execute unless score Stopped Temp matches 1 run execute if block ~ ~-1 ~ minecraft:water run particle minecraft:splash ~ ~ ~ 0.2 0.2 0.2 0 5
execute unless score Stopped Temp matches 1 run execute if block ~ ~-1 ~ minecraft:lava run particle minecraft:lava ~ ~ ~ 0.1 0.1 0.1 0 1

#Clean up
kill @e[tag=TempMotion]
tag @e remove TempStridingCat
scoreboard players reset Stopped Temp

#End striding ability conditions...
#If no longer above liquids
execute unless block ~ ~-0.9 ~ #minecraft:liquids run execute unless entity @e[tag=NearHoney] run scoreboard players set OutcomeEndStridingAbility Temp 1
#If player died this tick
execute if entity @s[tag=Died] run scoreboard players set OutcomeEndStridingAbility Temp 1
#If no stamina left
execute if score @s StatStamCurr matches ..0 run scoreboard players set OutcomeEndStridingAbility Temp 1

#If a condition passed, end ability
execute if score OutcomeEndStridingAbility Temp matches 1 run function terra_system:abilities/striding/end

#Clean up
scoreboard players reset OutcomeEndStridingAbility Temp
tag @e remove NearHoney











