#/function terra_system:stats/calculate_defense
#Created by Mithey

#PARAMETERS:
#DontDisplayMessage Temp - Displays total defense and how much you gained or lost

#RETURNS:
#@s Defense - How much defense you have

#Reset defense
scoreboard players set @s Defense 0

#Armor defense
scoreboard players operation @s Defense += @s DefenseFeet
scoreboard players operation @s Defense += @s DefenseLegs
scoreboard players operation @s Defense += @s DefenseChest
scoreboard players operation @s Defense += @s DefenseHead

#Weapon defense
scoreboard players operation @s Defense += @s DefenseWeapon1
scoreboard players operation @s Defense += @s DefenseWeapon2

#Level defense
scoreboard players operation DefenseLevel Temp = TerraRestore Level
scoreboard players operation DefenseLevel Temp *= 4 Number
scoreboard players operation @s Defense += DefenseLevel Temp

#Set total defense
scoreboard players operation OldDefenseTotal Temp = @s StatDefense
scoreboard players operation @s StatDefense = @s Defense

#Zone defense
scoreboard players operation @s Defense -= TerraRestore DefenseZone

#Display total defense
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation DefenseGain Temp = @s StatDefense
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation DefenseGain Temp -= OldDefenseTotal Temp
execute unless score DontDisplayMessage Temp matches 1 run tellraw @s {"translate":"","extra":[{"translate":"terra.stats.defense"},{"translate":": "},{"score":{"name":"@s","objective":"StatDefense"},"bold":true,"color":"aqua"},{"translate":" ("},{"translate":"terra.stats.you_gained","color":"gray"},{"translate":" "},{"score":{"name":"DefenseGain","objective":"Temp"},"bold":true,"color":"aqua"},{"translate":")","color":"gray"}]}

function terra_system:stats/calculate_defense_percent

#Clean up
scoreboard players reset DefenseGain Temp
scoreboard players reset OldDefenseTotal Temp
scoreboard players reset DefenseLevel Temp
scoreboard players reset DontDisplayMessage Temp
scoreboard players reset DontMakeSound Temp








