#/function terra_system:stats/calculate_offense
#Created by Mithey

#PARAMETERS:
#DontDisplayMessage Temp - Displays total offense and how much you gained or lost

#RETURNS:
#@s Offense - How much offense you have

#Reset offense
scoreboard players set @s Offense 0

#Armor offense
scoreboard players operation @s Offense += @s OffenseFeet
scoreboard players operation @s Offense += @s OffenseLegs
scoreboard players operation @s Offense += @s OffenseChest
scoreboard players operation @s Offense += @s OffenseHead

#Weapon offense
scoreboard players operation @s Offense += @s OffenseWeapon1
scoreboard players operation @s Offense += @s OffenseWeapon2

#Level offense
scoreboard players operation OffenseLevel Temp = TerraRestore Level
scoreboard players operation OffenseLevel Temp *= 4 Number
scoreboard players operation @s Offense += OffenseLevel Temp

#Set total offense
scoreboard players operation OldOffenseTotal Temp = @s StatOffense
scoreboard players operation @s StatOffense = @s Offense

#Zone offense
scoreboard players operation @s Offense -= TerraRestore OffenseZone

#Display total offense
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation OffenseGain Temp = @s StatOffense
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation OffenseGain Temp -= OldOffenseTotal Temp
execute unless score DontDisplayMessage Temp matches 1 run tellraw @s {"translate":"","extra":[{"translate":"terra.stats.offense"},{"translate":": "},{"score":{"name":"@s","objective":"StatOffense"},"bold":true,"color":"aqua"},{"translate":" ("},{"translate":"terra.stats.you_gained","color":"gray"},{"translate":" "},{"score":{"name":"OffenseGain","objective":"Temp"},"bold":true,"color":"aqua"},{"translate":")","color":"gray"}]}

#Update attack damage attribute
scoreboard players set DontDisplayMessage Temp 1
scoreboard players set DontMakeSound Temp 1
function terra_system:items/legs/update_attributes

function terra_system:stats/calculate_offense_percent

#Clean up
scoreboard players reset OffenseGain Temp
scoreboard players reset OldOffenseTotal Temp
scoreboard players reset OffenseLevel Temp
scoreboard players reset DontDisplayMessage Temp
scoreboard players reset DontMakeSound Temp








