#/function terra_system:stats/calculate_stamina
#Created by Mithey

#PARAMETERS:
#DontDisplayMessage Temp - Displays total Stam and how much you gained or lost

#RETURNS:
#@s Stam - How much Stam you have

#Store old stamina
scoreboard players operation OldStamTotal Temp = @s StatStamMax

#Reset Stam
scoreboard players set @s StatStamMax 12500

#Armor Stam
scoreboard players operation @s StatStamMax += @s StamFeet
scoreboard players operation @s StatStamMax += @s StamLegs
scoreboard players operation @s StatStamMax += @s StamChest
scoreboard players operation @s StatStamMax += @s StamHead

#Weapon Stam
scoreboard players operation @s StatStamMax += @s StamWeapon1
scoreboard players operation @s StatStamMax += @s StamWeapon2

#Display total Stam
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation TotalStam Temp = @s StatStamMax
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation TotalStam Temp /= 100 Number
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation StamGain Temp = @s StatStamMax
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation StamGain Temp -= OldStamTotal Temp
execute unless score DontDisplayMessage Temp matches 1 run scoreboard players operation StamGain Temp /= 100 Number
execute unless score DontDisplayMessage Temp matches 1 run tellraw @s {"translate":"","extra":[{"translate":"terra.stats.stamina"},{"translate":": "},{"score":{"name":"TotalStam","objective":"Temp"},"bold":true,"color":"aqua"},{"translate":" ("},{"translate":"terra.stats.you_gained","color":"gray"},{"translate":" "},{"score":{"name":"StamGain","objective":"Temp"},"bold":true,"color":"aqua"},{"translate":")","color":"gray"}]}

function terra_system:stamina/stamina_bar/update

#Clean up
scoreboard players reset StamGain Temp
scoreboard players reset OldStamTotal Temp
scoreboard players reset TotalStam Temp
scoreboard players reset DontDisplayMessage Temp
scoreboard players reset DontMakeSound Temp








